\section*{Acknowledgment}
Authors are grateful to CAPES (grant \#88881.145912/2017-01), CNPq (grant \#307560/2016-3), FAPESP (grants \#2014/12236-1, \#2015/24494-8, \#2016/50250-1, and \#2017/20945-0) and the FAPESP-Microsoft Virtual Institute (grants \#2013/50155-0, \#2013/50169-1, and \#2014/50715-9).
